////////////////////////////////////////////////////
// file: robot.cpp                                //
//                                                //
// task: defines the robot class that allows      //
//       to send movement commands to the Robo    //
//       Sapien by producing the same windows     //
//       events that are added to the event       //
//       queue when a user presses the movement   //
//       buttons of the UltraMote Controll.       //
//                                                //
// authors: Team NimbRo,                          //
//          Albert-Ludwigs-University of Freiburg //
//          Germany                               //
//          www.nimbro.net                        //
//          September 2004                        //
//                                                //
// compile: the source-code was programmed and    //
//          compiled with Microsoft's eMbedded    //
//          Visual C++ 3.0 IDE as a part of the   //
//          eMbedded Visual Tools 3.0 - 2002      //
//          Edition. Can be downloaded and used   //
//          for free from www.microsoft.com       //
////////////////////////////////////////////////////


///////////////////
// include files //
///////////////////

// Robo Sapien can perform two different types of steps
const int STEPTYPE_BIGSTEPS   = 0;
const int STEPTYPE_SMALLSTEPS = 1;

enum UpperArmPosition { Lowest, Lower, Middle, Upper };
enum LowerArmPosition { Inner, Center, Outer };
enum Side { Left, Right };
//enum TiltDirection { Left, Right };


//////////////////////
// class definition //
//////////////////////
class robot {

	public:
		robot();
		~robot();
		void Move(int _cm, int _StepType);
		void Turn(int _deg);
		void Stop();
		void MoveUpperArm(UpperArmPosition pos, Side side);
		void MoveLowerArm(LowerArmPosition pos, Side side);
		void TiltTrunk(Side side);
		
		
	private:
		void clickUltraMoteCoordinate(int _x, int _y);
		void clickUltraMoteButton(int _column, int _row);
		UpperArmPosition currentUpperArmPosition[2];
		LowerArmPosition currentLowerArmPosition[2];

}; // end-class robot
